import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib

# Exercice 1

eps=10**(-11)
x0=[2]
x0=np.array(x0)
tabx,tabcrit,it=met.meth_newton(lib.f1,lib.df1,x0,eps)
print('Nombre d''itérations: ',it)
print('Zero atteint en x= ',tabx[0:,it])
print('f(x)= ',tabcrit[it])

xinf=tabx[0:,it]
t=np.linspace(0,2,101)
t0=lib.f1(0)
t1=lib.f1(2)
yt=lib.f1(t)
pl.plot(t,yt,linewidth=0.5,color='black')
pl.plot([xinf,xinf],[t0,t1],[0,2],[0,0],linewidth=0.5,color='grey')
for x in tabx:
    yx=lib.f1(x)
    pl.plot([x,x],[yx-0.1,yx+0.1],linewidth=0.5,color='red')
    pl.plot([x-0.02,x+0.02],[yx,yx],linewidth=0.5,color='red')
pl.show()
pl.close()

err=[abs(tabx[0][i]-tabx[0][it]) for i in range(it)]
err=np.array(err)
pentex=err[:-1]
pentey=err[1:]
pentex=np.log(pentex)
pentey=np.log(pentey)
pente=[(pentey[i+1]-pentey[i])/(pentex[i+1]-pentex[i]) for i in range(len(pentex)-1)]
pente=np.array(pente)
print('pente= ',pente)

pl.plot(pentex,pentey,linewidth=0.5,color='black')
pl.show()
pl.close()


#

eps=10**(-3)
x0=np.array([-1])
tabx,tabcrit,it=met.meth_newton(lib.f1,lib.df1,x0,eps)
print('Nombre d''itérations: ',it)
print('Zero atteint en x= ',tabx[0:,it])
print('f(x)= ',tabcrit[it])

xinf=tabx[0:,it]
t=np.linspace(-1,6,701)
t0=lib.f1(-1)
t1=lib.f1(6)
yt=lib.f1(t)
pl.plot(t,yt,linewidth=0.5,color='black')
pl.plot([xinf,xinf],[t0,t1],[-1,6],[0,0],linewidth=0.5,color='grey')
for x in tabx:
    yx=lib.f1(x)
    pl.plot([x,x],[yx-4,yx+4],linewidth=0.5,color='red')
    pl.plot([x-0.05,x+0.05],[yx,yx],linewidth=0.5,color='red')
pl.show()
pl.close()


err=[abs(tabx[0][i]-tabx[0][it]) for i in range(it)]
err=np.array(err)
pentex=err[:-1]
pentey=err[1:]
pentex=np.log(pentex)
pentey=np.log(pentey)
pente=[(pentey[i+1]-pentey[i])/(pentex[i+1]-pentex[i]) for i in range(len(pentex)-1)]
pente=np.array(pente)
print('pente= ',pente)

pl.plot(pentex,pentey,linewidth=0.5,color='black')
pl.show()
pl.close()


