import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib



eps=10**(-11)
x0=[-0.03,2]
x0=np.array(x0)

theta=np.linspace(0,2*np.pi,600)
tx=np.sqrt(2)*np.cos(theta)
ty=np.sqrt(2)*np.sin(theta)
pl.plot(tx,ty,linewidth=0.5,color='black')

#t=np.linspace(-1.5,1.5,301)
t=np.linspace(-3,3,601)
tx=np.cosh(t)
ty=np.sinh(t)
pl.plot(tx,ty,linewidth=0.5,color='black')
tx=-tx
pl.plot(tx,ty,linewidth=0.5,color='black')
pl.plot([-10,10],[0,0],linewidth=0.5,color='grey')
pl.plot([0,0],[-10,10],linewidth=0.5,color='grey')
#pl.show()
#pl.close()


tabx,tabcrit,it=met.meth_newton(lib.f2,lib.df2,x0,eps)
xinf=tabx[0,it]
yinf=tabx[1,it]
print('Nombre d''itérations: ',it)
print('Zero atteint en x= ',tabx[0:,it])
print('f(x)= ',tabcrit[it])

xx=tabx[0,0:it]
yy=tabx[1,0:it]
pl.plot(xx,yy,linewidth=0.5,color='red')
pl.plot([xinf,xinf],[yinf-0.1,yinf+0.1],linewidth=2,color='blue')
pl.plot([xinf-0.1,xinf+0.1],[yinf,yinf],linewidth=2,color='blue')

pl.show()
pl.close()

x=xx[-1]
y=yy[-1]
errx=[abs(xx[i]-x) for i in range(it)]
errx=np.array(errx)
erry=[abs(yy[i]-y) for i in range(it)]
erry=np.array(erry)

taberr0=np.zeros(it)
i=0
for xi in errx:
    yi=erry[i]
    erri=sp.linalg.norm([xi,yi])
    taberr0[i]=erri
    i += 1
taberr=taberr0[1:-1]    
taberrx=taberr[:-1]
taberry=taberr[1:]
taberrx=np.log(taberrx)
taberry=np.log(taberry)
pl.plot(taberrx,taberry,linewidth=0.5,color='black')
pl.show()
pl.close()

pente=[taberry[i]/taberrx[i] for i in range(len(taberrx))]
print('pente= ',pente)
    
    


        
