import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib



x0=np.array([-0.5]) #x0=np.array([-1]) #x0=np.array([2]) #x0=np.array([0])
eps=10**(-11)

t=np.linspace(-1,2,301)
t0=lib.f3(-1)
t1=lib.f3(2)
yt=lib.f3(t)
pl.plot(t,yt,linewidth=0.5,color='black')
pl.plot([-1,2],[0,0],[0,0],[-1,t1],linewidth=0.5,color='grey')

tabx,tabcrit,it=met.meth_newton(lib.f3,lib.df3,x0,eps)

xinf=tabx[0,it]
yinf=tabcrit[it]
print('Nombre d''itérations: ',it)
print('Zero atteint en x= ',tabx[0,it])
print('f(x)= ',tabcrit[it])

pl.plot([xinf,xinf],[yinf-0.25,yinf+0.25],linewidth=2,color='red')


#tx=tabx[0,0:it]
#ftx=lib.f3(tx)
#pl.plot(tx,ftx,linewidth=0.5,color='blue')
for x in tabx:
    yx=lib.f3(x)
    pl.plot([x,x],[yx-0.2,yx+0.2],linewidth=0.5,color='red')
    pl.plot([x-0.05,x+0.05],[yx,yx],linewidth=0.5,color='red')  
pl.show()
pl.close()


err=[abs(tabx[0][i]-tabx[0][it]) for i in range(it)]
err=np.array(err)
pentex=err[:-1]
pentey=err[1:]
pentex=np.log(pentex)
pentey=np.log(pentey)
pente=[(pentey[i+1]-pentey[i])/(pentex[i+1]-pentex[i]) for i in range(len(pentex)-1)]
pente=np.array(pente)
print('pente= ',pente)

pl.plot(pentex,pentey,linewidth=0.5,color='black')
pl.show()
pl.close()



