function y=f1(x)
y=exp(x)-%e;

endfunction

function y=df1(x)
y=exp(x);

endfunction


function y=f2a(x)

x1=x(1);
x2=x(2);

y=[x1^2+x2^2-2;x1^2-x2^2-1];

endfunction 

function y=df2a(x)

x1=x(1);
x2=x(2);

y=[2*x1 2*x2;2*x1 -2*x2];

endfunction


function y=f2(x)
y=(exp(x)-%e).^2;
endfunction

function y=df2(x)
y=2*(exp(x)-%e).*exp(x);
endfunction


function y=f3(x)
y=(sqrt(exp(x)-%e)).^5;
endfunction

function y=df3(x)
y=5*(sqrt(exp(x)-%e)).^3.*exp(x)/2;
endfunction





function y=f5(x)

t=0:0.1:1;
y=inttrap(t,sin(x*exp(t.^2)))-0.5;

endfunction


function y=df5(x)

t=0:0.1:1;
y=x*inttrap(t,cos(x*exp(t.^2)).*exp(t.^2));

endfunction





function y=f6(u)

N=2+length(u);
N2=N*N;
v=u;
v=[0;v;0];
for n=2:N-1
v(n)=1+cos(%pi*(n-1)/(N-1))^2;
end
v(1)=[];
v($)=[];
a=-2*diag(v)+diag(v(2:$),+1)+diag(v(1:$-1),-1);
y=N2*a*u-u.^2;
y(1)=y(1)+2*N2;
y($)=y($)+4*N2; 
endfunction




function y=df6(u)

N=2+length(u);
N2=N*N;
v=u;
v=[0;v;0];
for n=2:N-1
v(n)=1+cos(%pi*(n-1)/(N-1))^2;
end
v(1)=[];
v($)=[];
a=-2*diag(v)+diag(v(2:$),+1)+diag(v(1:$-1),-1);
y=N2*a-2*diag(u);
endfunction


function yN=f7(a)
// le second membre a été choisi pour que la solution soit x^2:
// -u''+u^3=-2+x^6

N=10;
h=1/(N+1);
x=linspace(0,1,N+2);
x=x.^6;
h2=h*h;
y0=0;
y1=h*a;
y=[y0;y1];
for i=3:N+2
yi=2*y1-y0+h2*(y1^3+2-x(i));
y=[y;yi];
y0=y1;
y1=yi;
end
yN=yi-1;



endfunction



function y=f7N(a)

N=10;
h=1/(N+1);
x=linspace(0,1,N+2);
x=x.^6;
h2=h*h;
y0=0;
y1=h*a;
y=[y0;y1];
for i=3:N+2
yi=2*y1-y0+h2*(y1^3+2-x(i));
y=[y;yi];
y0=y1;
y1=yi;
end
yN=yi-1;



endfunction




function yN=df7(a)

//N=10;
h=1/(N+1);
x=linspace(0,1,N+2);
x=x.^6;
h2=h*h;
y0=0;
z0=0;
y1=h*a;
z1=h;
y=[y0;y1];
z=[z0;z1];
for i=3:N+2
yi=2*y1-y0+h2*(y1^3+6-x(i));
zi=2*z1-z0+3*h2*y1^2*z1;
y=[y;yi];
z=[z;zi];
y0=y1;
y1=yi;
z0=z1;
z1=zi;
end
yN=zi;



endfunction

